﻿(function (window, $) {
	'use strict';

	$.CallbackManager = function () {
		var list = [],

        self = {
        	add: function (cb) {
        		if (cb && typeof (cb) === 'function') {

        			if ($.inArray(cb, list) === -1) {
        				list.push(cb);
        			}
        		}
        		return this;
        	},

        	remove: function (cb) {
        		if (cb && typeof (cb) === 'function') {
        			var index;
        			while ((index = jQuery.inArray(cb, list)) > -1) {
        				list.splice(index, 1);
        			}
        		}
        		return this;
        	},

        	fire: function () {
        		for (var index = 0; index < list.length; index++) {
        			try {
        				list[index].apply(null, arguments);
        			}
        			catch (e) { }
        		}
        	}
        };

		return self;
	};

})(window, window.jQuery);

window.EmailNotifications = $.CallbackManager();
window.FriendLoginNotifications = $.CallbackManager();
