﻿
// kludge, add an extra binding for css so we can mix'n match class/value type
ko.bindingHandlers.css2 = {
	'update': function (element, valueAccessor) {
		var value = ko.utils.unwrapObservable(valueAccessor());
		if (typeof value == "object") {
			for (var className in value) {
				var shouldHaveClass = ko.utils.unwrapObservable(value[className]);
				ko.utils.toggleDomNodeCssClass(element, className, shouldHaveClass);
			}
		} else {
			value = String(value || ''); // Make sure we don't try to store or set a non-string value
			value = value.replace('/', '-');
			ko.utils.toggleDomNodeCssClass(element, value, true);
		}
	}
};



// https://github.com/khayrov/khayrov.github.com/tree/master/jsfiddle/knockout-fileapi
var windowURL = window.URL || window.webkitURL;
ko.bindingHandlers.file = {
	init: function (element, valueAccessor) {
		$(element).change(function () {
			var file = this.files[0];
			if (ko.isObservable(valueAccessor())) {
				valueAccessor()(file);
			}
		});
	},

	update: function (element, valueAccessor, allBindingsAccessor) {
		var file = ko.utils.unwrapObservable(valueAccessor());
		var bindings = allBindingsAccessor();

		if (bindings.fileObjectURL && ko.isObservable(bindings.fileObjectURL)) {
			var oldUrl = bindings.fileObjectURL();
			if (oldUrl) {
				windowURL.revokeObjectURL(oldUrl);
			}
			bindings.fileObjectURL(file && windowURL.createObjectURL(file));
		}

		if (bindings.fileBinaryData && ko.isObservable(bindings.fileBinaryData)) {
			if (!file) {
				bindings.fileBinaryData(null);
			} else {
				var reader = new FileReader();
				reader.onload = function (e) {
					bindings.fileBinaryData(e.target.result);
				};
				reader.readAsArrayBuffer(file);
			}
		}

		if (bindings.fileDataURL && ko.isObservable(bindings.fileDataURL)) {
			if (!file) {
				bindings.fileDataURL(null);
			} else {
				var reader = new FileReader();
				reader.onload = function (e) {
					bindings.fileDataURL(e.target.result);
				};
				reader.readAsDataURL(file);
			}
		}
	}
};
